const suchfeld = document.getElementById("id_suchfeld");
suchfeld.setAttribute('list', "vorschlaege");

const datalist = document.createElement("datalist");
datalist.setAttribute('id', "vorschlaege");
suchfeld.after(datalist);

function debounce(func, timeout = 300) {
    let timer;
    return (...args) => {
      clearTimeout(timer);
      timer = setTimeout(() => { func.apply(this, args); }, timeout);
    };
}

async function optionen(event) {
    const url = window.location.pathname;
    const suche = event.target.value
        .trim()
        .replace(/[^a-z0-9@ ]/gi, '');
    let bereits_option = false;
    for (let option of datalist.getElementsByTagName("option"))
        bereits_option |= option.value === suche;    
    if ( !bereits_option ) {
        datalist.innerHTML = "";
        try {
            const antwort = await fetch(
                `${url}?suchfeld=${suche.replace(/\s/g, '+')}`,
                {
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    method: 'GET',
                }
            ); 
            const vorschlaege = (await antwort.json())['vorschlaege'];
            for(let vorschlag in vorschlaege) {
                const option = document.createElement("option");
                option.setAttribute('value', vorschlaege[vorschlag]);
                datalist.appendChild(option);
            }
        } catch (error) {
            console.log(error);
        }
    }
}

suchfeld.addEventListener('input', debounce(optionen));
